# OpenSSL auto-compiler

### Motivation

Tons of software still use OpenSSL 1.0.2, and the fact that different versions can&#39;t coexist in a Linux distribution is a big problem. My solution: Create a script that automatically downloads and upgrades OpenSSL 1.0.2.

### Expected result from this script

This script automatically checks the latest version of OpenSSL, downloads it, extracts it, compiles it and creates a soft-link with a name that you can keep using without having to rename anything.

### Using the script

You can use this script in two different ways:

1. Simply call it using `python CompileOpenSSL-1.0.2-Linux.py`. This will download the latest version of OpenSSL and compile it.
2. Call `python CompileOpenSSL-1.0.2-Linux.py openssl-1.0.2x.tar.gz`, where the filename is the OpenSSL version to be compiled.

After compilation is finished, a symbolic link with the name `openssl_build` will be created, which will link to the compiled binaries. This symbolic link will help in keeping the path unchanged when upgrading to a newer version of OpenSSL.

### Upgrading OpenSSL

OpenSSL is a security software. Depending on how you use it, it's recommneded that you upgrade it regularly.

To upgrade, just run the same script again, preferably with `python CompileOpenSSL-1.0.2-Linux.py`. This will check if newer versions exist, compile them, and relink them to the same directory (`openssl_build`).

Note: The current script will recompile OpenSSL anyway, whether a newer version exists or not.

